﻿Public Class Form1
    Dim palette8 As Imaging.ColorPalette
    Dim bmp4bpp As Bitmap
    Dim Vbar() As VScrollBar
    Dim maxLevel As Byte
    Dim labLevel() As Label

    Private Sub ButOPEN_Click(sender As Object, e As EventArgs) Handles ButOPEN.Click
        Dim ofd As OpenFileDialog = New OpenFileDialog()
        ofd.Filter = "Images(*.bmp *.tif *.tiff *.gif)|*.bmp;*.tif;*.tiff; *.gif|Tutti i file (*.*)|*.*"
        ofd.RestoreDirectory = True
        If ofd.ShowDialog() = DialogResult.OK Then
            Me.Text = ofd.FileName
            Dim bmp8bpp As Bitmap = New Bitmap(ofd.FileName) ' in bmp8bpp l'immagine scelta
            Dim palette As Imaging.ColorPalette = bmp8bpp.Palette ' in palette, la palette dell'immagine scelta
            If palette.Entries.Length = 256 Then
                LabINFO.Text = bmp8bpp.Width & "x" & bmp8bpp.Height & " " & bmp8bpp.PixelFormat.ToString & ", L' immagine ha una palette da " & palette.Entries.Length & " colori"
            Else
                azzera()
                LabINFO.Text = "ERRORE " & bmp8bpp.Width & "x" & bmp8bpp.Height & " " & bmp8bpp.PixelFormat.ToString & ", L' immagine non è a 8bpp"
                Exit Sub
            End If
            ' blocco i bit della bitmap     
            Dim area8 As Rectangle = New Rectangle(0, 0, bmp8bpp.Width, bmp8bpp.Height)
            Dim bmpData8 As System.Drawing.Imaging.BitmapData = bmp8bpp.LockBits(area8, Drawing.Imaging.ImageLockMode.ReadWrite, bmp8bpp.PixelFormat)
            Dim ptr8 As IntPtr = bmpData8.Scan0 ' puntatore all'indirizzo di memoria del primo byte.
            Dim bytes8 As Integer = Math.Abs(bmpData8.Stride) * bmp8bpp.Height ' calcolo dei bytes necessari
            Dim colorValues(bytes8 - 1) As Byte ' un array che conterrà tutti i bytes della bitmap.
            ' nel vettore colorValues metto i dati dalla locazione ptr che rappresentano clone4bpp
            System.Runtime.InteropServices.Marshal.Copy(ptr8, colorValues, 0, bytes8)
            bmp4bpp = New Bitmap(bmp8bpp.Width, bmp8bpp.Height, Imaging.PixelFormat.Format4bppIndexed)
            ' blocco i bit della bitmap     
            Dim area4 As Rectangle = New Rectangle(0, 0, bmp4bpp.Width, bmp4bpp.Height)
            Dim bmpData4 As System.Drawing.Imaging.BitmapData = bmp4bpp.LockBits(area4, Drawing.Imaging.ImageLockMode.ReadWrite, bmp4bpp.PixelFormat)
            palette8 = bmp4bpp.Palette
            'creo una palette con i livelli scelti
            For i = 0 To palette8.Entries.Length - 1
                If i > maxLevel Then
                    palette8.Entries(i) = Color.Black
                Else
                    palette8.Entries(i) = Color.FromArgb(i * 255 \ maxLevel, i * 255 \ maxLevel, i * 255 \ maxLevel)
                    Vbar(i).Value = i * 255 \ maxLevel ' metto il valore negli slider
                    labLevel(i).Text = i * 255 \ maxLevel ' visualizzo il valore
                End If
            Next i
            bmp4bpp.Palette = palette8
            Dim ptr4 As IntPtr = bmpData4.Scan0
            Dim bytes4 As Long = Math.Abs(bmpData4.Stride) * bmp4bpp.Height ' calcolo dei bytes necessari
            Dim levelValues(bytes4 - 1) As Byte
            ' In base alle dimensioni il vettore a 4bpp, non sempre viene la metà del vettore a 8bpp
            Dim correttivo As Single = levelValues.Length / (bmpData8.Stride * bmp8bpp.Height / 2)
            Dim ind8 As Integer = 0
            Dim ind4 As Integer = 0
            For riga = 0 To bmp8bpp.Height + 1
                For colonna = 0 To bmp8bpp.Width + 1
                    ind8 = colonna + riga * (bmpData8.Stride - 2)  ' calcolo l'indice per colorValues
                    ind4 = Math.Truncate((ind8 \ 2) * correttivo)  ' calcolo l'indice per levelValues (correttivo non è sempre perfetto)
                    If ind4 > levelValues.GetUpperBound(0) Or ind8 > colorValues.GetUpperBound(0) Then Exit For
                    If ind8 Mod 2 = 0 Then ' ind8 pari, per il pixel a sinistra
                        levelValues(ind4) = (colorValues(ind8) \ (255 / (maxLevel + 1))) << 4 ' scrivo a destra ma poi scorrimento a sinistra (come moltiplicare per 16)
                    Else ' ind8 dispari, per il pixel a destra
                        Dim semibyteSinistro As Byte = levelValues(ind4) ' il vecchio pixel a sinistra
                        Dim semibyteDestro As Byte = colorValues(ind8) \ (255 / (maxLevel + 1)) ' il nuovo pixel che deve andare a destra
                        levelValues(ind4) = semibyteSinistro + semibyteDestro ' ricompongo il byte con i due pixel
                    End If
                Next
            Next
            'ripristino vettore su immagine
            System.Runtime.InteropServices.Marshal.Copy(colorValues, 0, ptr8, bytes8)
            bmp8bpp.UnlockBits(bmpData8) ' sblocco bit
            PictureBox1.Image = bmp8bpp
            ' ripristino vettore su immagine
            System.Runtime.InteropServices.Marshal.Copy(levelValues, 0, ptr4, bytes4)
            bmp4bpp.UnlockBits(bmpData4) ' sblocco bit
            PictureBox2.Image = bmp4bpp
        End If
    End Sub

    Private Sub ButSAVE_Click(sender As Object, e As EventArgs) Handles ButSAVE.Click
        If IsNothing(bmp4bpp) Then Exit Sub
        Dim sfd As SaveFileDialog = New SaveFileDialog()
        sfd.Filter = "Images(*.bmp)|*.bmp|Tutti i file (*.*)|*.*"
        sfd.RestoreDirectory = True
        If sfd.ShowDialog() = DialogResult.OK Then
            Me.Text = sfd.FileName
            bmp4bpp.Save(sfd.FileName, Imaging.ImageFormat.Bmp)
        End If
    End Sub

    Private Sub VScrollBar_Scroll(sender As Object, e As ScrollEventArgs)
        If IsNothing(bmp4bpp) Then Exit Sub
        palette8.Entries(CType(sender.tag, Integer)) = Color.FromArgb(e.NewValue, e.NewValue, e.NewValue)
        labLevel(CType(sender.tag, Integer)).Text = e.NewValue
        bmp4bpp.Palette = palette8
        PictureBox2.Image = bmp4bpp
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox1.SelectedIndexChanged
        maxLevel = 2 ^ (ComboBox1.SelectedIndex + 1) - 1
        azzera()
    End Sub

    Sub azzera()
        Panel1.Controls.Clear()
        PictureBox1.Image = Nothing
        PictureBox2.Image = Nothing
        Me.Text = "Carica un'immagine 8bpp"
        LabINFO.Text = "Carica un'immagine 8bpp"
        ReDim Vbar(maxLevel)
        ReDim labLevel(maxLevel)

        For v = 0 To maxLevel
            Vbar(v) = New VScrollBar
            Vbar(v).Name = "VscrollBar" & v.ToString()
            Vbar(v).Tag = v
            Vbar(v).Top = 10
            Vbar(v).Left = 9 + v * 31
            Vbar(v).Maximum = 255
            Vbar(v).LargeChange = 1
            AddHandler Vbar(v).Scroll, AddressOf VScrollBar_Scroll
            Panel1.Controls.Add(Vbar(v))
            labLevel(v) = New Label
            labLevel(v).Name = "Label" & v.ToString()
            labLevel(v).Tag = v
            labLevel(v).Top = 94
            labLevel(v).Left = 4 + v * 31
            labLevel(v).Text = ""
            labLevel(v).AutoSize = False
            labLevel(v).Width = 30
            labLevel(v).BorderStyle = BorderStyle.FixedSingle
            labLevel(v).TextAlign = ContentAlignment.MiddleCenter
            Panel1.Controls.Add(labLevel(v))
        Next
    End Sub

    Private Sub ButINVERT_Click(sender As Object, e As EventArgs) Handles ButINVERT.Click
        If IsNothing(bmp4bpp) Then Exit Sub
        Dim paletteTMP As Imaging.ColorPalette = bmp4bpp.Palette
        For i = 0 To maxLevel
            palette8.Entries(i) = paletteTMP.Entries(maxLevel - i)
            Vbar(i).Value = palette8.Entries(i).R ' metto il valore negli slider
            labLevel(i).Text = palette8.Entries(i).R ' visualizzo il valore
        Next i
        bmp4bpp.Palette = palette8
        PictureBox2.Image = bmp4bpp
    End Sub
End Class
